#!/usr/bin/perl -w
# not strict at all :)
#initialize genome name and base_hash
$my_genome = "";
$genome='';
@bases=();
%nmer=();
#assign genome name to $my_genome
@dir=`ls`;
#assumes one *.fna file in directory

foreach (@dir) {
   if (m/\.fna$/) {if ($my_genome) {die "More then one genome in directory"} else {$my_genome=($_)}
   }
}
######
chomp ($my_genome);

print "\n\n$my_genome is the file name of the genome to be analyzed \n";

# open my genome for input

open (IN, "< $my_genome") or die "cannot open $my_genome:$!";

# open my_table for output
open (OUT, ">my_table" ) or die "cannot open my_table" ;

print OUT "number \tketoexcess\tCoverGscew\tAoverTscew\tGCbias\tbase_hash{A}\tbase_hash{T}\tbase_hash{G}\tbase_hash{C}\n";# if we want to use exel, we can print a header in the first line";

$header = <IN>;
#reads first line of file, next command test for fasta commentline

if ($header =~m/^>/) {print "\nthe analyzed genome has the following comment line:\n$header \n\n"};

if (!($header =~m/^>/)) {print "this is not in FASTA format \n\n";
			exit;}
###			exit - could have died instead;

#$number=0;

$genome='';
while (defined ($line=<IN>)){

	chomp($line);
	$genome .=$line;
	}
close(IN);

@bases=split(//,$genome);
$count=@bases;    

for(my $i = 0; $i < $count-3; $i++){
    $subseq = $bases[$i].$bases[$i+1].$bases[$i+2].$bases[$i+3];
    $nmer{$subseq}++;
    #Make rev complement of subseq:
    $subseq=~ tr/ATGCYRatcgyr/TACGRYTAGCRY/;
    $subseq= reverse $subseq;
    $nmer{$subseq}++;
}

@sorted_by_value = sort { $nmer{$a} <=> $nmer{$b} or $a cmp $b} keys %nmer;

foreach (@sorted_by_value) {
    print "tetramer \t $_ \t occurred $nmer{$_}   times\n";
    print OUT "$_\t$nmer{$_}\n" ;
 
}
close (OUT);

# modify the script so that the user (or another program) can assign the size of the nmer as a variable!





