#!/usr/bin/perl -w
# not strict at all :)
#initialize genome name and base_hash
$my_genome = "";
$genome='';
@bases=();
%nmer=();
#assign genome name to $my_genome
@dir=`ls`;
#assumes one *.fna file in directory

foreach (@dir) {
   if (m/\.fna$/) {if ($my_genome) {die "More then one genome in directory"} else {$my_genome=($_)}
   }
}
######
chomp ($my_genome);

print "\n\n$my_genome is the file name of the genome to be analyzed \n";

# open my genome for input

open (IN, "< $my_genome") or die "cannot open $my_genome:$!";

# open my_table for output
open (OUT, ">indata" ) or die "cannot open my_table" ;



$header = <IN>;
#reads first line of file, next command test for fasta commentline

if ($header =~m/^>/) {print "\nthe analyzed genome has the following comment line:\n$header \n\n"};

if (!($header =~m/^>/)) {print "this is not in FASTA format \n\n";
			exit;}
###			exit - could have died instead;



$genome='';
while (defined ($line=<IN>)){

	chomp($line);
	$genome .=$line;
	}
close(IN);

@bases=split(//,$genome);
$count=@bases;    
$number=8; #nmer  ## change this number for different sized kmers. 
print OUT "$number"."mer\n" ;# for histogram script;
for(my $i = 0; $i < $count-$number+1; $i++){
	$subseq='';
    for (my $k=0; $k < $number; $k++){
    $subseq = $subseq.$bases[$i+$k]; #for large kmers this is not very effective -better remove first add one new ...
    }
    
    $nmer{$subseq}++;
    #Make rev complement of subseq:
    $subseq=~ tr/ATGCYRatcgyr/TACGRYTAGCRY/;
    $subseq= reverse $subseq;
    $nmer{$subseq}++;
}

@sorted_by_value = sort { $nmer{$b} <=> $nmer{$a} or $a cmp $b} keys %nmer;

foreach (@sorted_by_value) {
    print "$number mer \t $_ \t occurred $nmer{$_}   times\n";
    print OUT "$nmer{$_}\n" ;
 
}
$number_of_differnet_nmers=@sorted_by_value;
print  "A total of $number_of_differnet_nmers differnt $number mers were encounteres.\n\n";
close (OUT);
system (" R CMD BATCH histogramScript_pdf.R"); #plot in plot1.pdf







